<?php
class cPRINTBASE {           
   protected $fpath=false;
   protected $fp=false;
   
   public $err=false;
   
   function __construct()  
   {
      $sh = new COM('WScript.Shell');      
      if ($sh===false) {
         $this->err = "Failed to create COM object";
         return;
      }
   
      try {   
         $path = $sh->RegRead('HKEY_LOCAL_MACHINE\\SOFTWARE\\INCA Hellas\\ApoPantou\\CommonDir');
      }
      catch (Exception $e) {
         $this->err = "Caught exception: ".$e->getMessage();
         return;
      }
      $sh=null; // clear from memory
      
      for ($i=0;$i<10;$i++) {
         while (true) {
            $this->fpath = $path."\\".time().".".mt_rand().".xml";
            if (!file_exists($this->fpath))
               break;
         }

         if (($this->fp = fopen($this->fpath, "xb"))!==false) {
            break;
         }
      }
      if ($this->fp===false) {
         $this->err = "Failed to create $this->fpath!";
         return;
      }
   }
   
   function __destruct()
   {
      if ($this->fp!==false) {
         fclose($this->fp);
         if (PHP_OS!=="WINNT") {
            chmod($this->fpath, 0666); // for UNIX filesystems
         } 
      }
   }
   
   function version()      
   {
      return "1.0.0.0";
   }
   
   function WriteData($xmls)   
   {
      if ($this->fp===false) {
         return false;
      }
      
      fwrite($this->fp, $xmls);   
   }
}
//--------------------------------------
class cPRINTJOB extends cPRINTBASE {
   private $pg_open=false;
   private $fontNR=0;
   private $penNR=0;
   private $brushNR=0;
   private $proxy_url=false;
   
   function __construct($ProxyUrl=false)
   {
      if (!empty($ProxyUrl)) {
         $this->proxy_url=$ProxyUrl;
         
         $this->fp = tmpfile();
         if ($this->fp===false) {
            $this->err = "tmpfile() failed";
         }
      }
      else {
         parent::__construct();
      }
      
      if ($this->err!==false)
         return;
      
      fwrite($this->fp, "<?xml version=\"1.0\" encoding=\"utf-8\" ?".">\r\n");
      fwrite($this->fp, "<ApoPantou creator=\"www.incahellas.com\">");
   }

   function __destruct()
   {
      $this->finalize();      
   }
   
   function finalize()
   {
      $bret=true;
      
      if ($this->fp!==false) {
         if ($this->pg_open) {
            fwrite($this->fp, "</Page>");
         }
         fwrite($this->fp, "</ApoPantou>");
         
         if ($this->proxy_url!==false) {
            $ch=false;
            
            do {
               if (!function_exists("curl_init")) {
                  $this->err="CURL not supported";
                  $bret=false;
                  break;
               }
               
               if (($ch=curl_init($this->proxy_url))===false) {
                  $this->err="curl_init() failed";
                  $bret=false;
                  break;
               }
               
               curl_setopt($ch, CURLOPT_POST, true);
               curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
               
               if (($sz=ftell($this->fp))===false) {
                  $this->err="ftell() failed";
                  $bret=false;
                  break;
               }
               if (rewind($this->fp)===false) {
                  $this->err="rewind() failed";
                  $bret=false;
                  break;
               }
               if (($xmldata=fread($this->fp,$sz))===false) {
                  $this->err="fread() failed";
                  $bret=false;
                  break;
               }
               $data = array('XMLDATA' => $xmldata);
               curl_setopt($ch, CURLOPT_POSTFIELDS, $data);

               if (($rets=curl_exec($ch))===false) {
                  $this->err="curl_exec() failed";
                  $bret=false;
                  break;
               }
               else if (trim($rets)!=="OK") {
                  $this->err=$rets;
                  $bret=false;
               }
               // else: o.k.
            } while (false);
            
            if ($ch!==false) {
               curl_close($ch);
            }
            
            fclose($this->fp);
            $this->fp=false;
         }
         else {
            fclose($this->fp);
            $this->fp=false;
            if (PHP_OS!="WINNT") {
               chmod($this->fpath, 0666); // for UNIX filesystems
            }
         } 
      }
      
      return $bret;
   }
   
   private function myxml($a)
   {
      static $trans=array('&'=>'&amp;', '<'=>'&lt;', '>'=>'&gt;', '"'=>'&quot;', '\''=>'&apos;' );   

      return strtr($a, $trans );
   }
   
   function set_printer($pname, $ar1=false)
   {
      if ($this->fp===false) {
         return false;
      }
      
      if ($this->pg_open) {
         return false;
      }
      fwrite($this->fp, "<Printer");

      if (is_array($ar1)) {
         foreach ($ar1 as $k1=>$v1) {
            fwrite($this->fp, " ".$this->myxml($k1)."=\"".$this->myxml($v1)."\"");
         }
      }

      return fwrite($this->fp, ">".$this->myxml($pname)."</Printer>");
   }
   
   function new_page()
   {
      if ($this->fp===false) {
         return false;
      }
      
      if ($this->pg_open) {
         if (!fwrite($this->fp, "</Page>"))
            return false;
      }
      if (fwrite($this->fp, "<Page>")) {
         $this->pg_open=true;
         return true;
      }
      else {
         return false;
      }
   }   
   
   function create_font($fontname, $sz, $attr=false)
   {
      if ($this->fp===false) {
         return false;
      }
      
      ++$this->fontNR;
      
      $sz=(int)$sz; // normalize
      fwrite($this->fp, "<Font id=\"$this->fontNR\" size=\"$sz\"");
      if (!empty($attr)) {
         fwrite($this->fp, " style=\"".$this->myxml($attr)."\"");
      }
      fwrite($this->fp, ">".$this->myxml($fontname)."</Font>");
      
      return $this->fontNR;
   }
   
   function create_pen($color, $sz)
   {
      if ($this->fp===false) {
         return false;
      }
      
      ++$this->penNR;
      
      $sz=(float)$sz; // normalize   
      fwrite($this->fp, "<Pen id=\"$this->penNR\" size=\"$sz\">".$this->myxml($color)."</Pen>");
      
      return $this->penNR;    
   }
   
   function create_brush($type, $var1, $var2=false, $var3=false)
   {
      if ($this->fp===false) {
         return false;
      }
      
      ++$this->brushNR;
      
      switch ($type)
      {
      case "solid":
         fwrite($this->fp, "<Brush id=\"$this->brushNR\" color=\"".$this->myxml($var1)."\">solid</Brush>");
         break;
      case "texture":
         fwrite($this->fp, "<Brush id=\"$this->brushNR\" image=\"".$this->myxml($var1)."\" wrapmode=\"".$this->myxml($var2)."\">texture</Brush>");
         break;
      case "gradient":
         fwrite($this->fp, "<Brush id=\"$this->brushNR\" color1=\"".$this->myxml($var1)."\" color2=\"".$this->myxml($var2)."\"");
         if (count($var3)==5) {
            $x=(float)$var3[0];
            $y=(float)$var3[1];
            $width=(float)$var3[2];
            $height=(float)$var3[3];
            fwrite($this->fp, " x=\"$x\" y=\"$y\" width=\"$width\" height=\"$height\" mode=\"".$this->myxml($var3[4])."\"");
         }
         fwrite($this->fp, ">gradient</Brush>");
         break;
      default:
         return false;
      }
      
      return $this->brushNR;
   }
   
   private function check_pg_open()
   {
      if (!$this->pg_open) {
         fwrite($this->fp, "<Page>");
         $this->pg_open=true;
      }
   }
   
   function draw_string($s1, $fontRC, $brushRC, $x, $y)
   {
      if ($this->fp===false) {
         return false;
      }
      
      $this->check_pg_open();
      
      $fontRC=(int)$fontRC; // normalize        
      $brushRC=(int)$brushRC; // normalize
      $x=(float)$x; // normalize
      $y=(float)$y; // normalize            
      return fwrite($this->fp, "<DrawString font=\"$fontRC\" brush=\"$brushRC\" x=\"$x\" y=\"$y\">".$this->myxml($s1)."</DrawString>");
   }
   
   function draw_next($s1, $fontRC=false, $brushRC=false, $dx=0, $dy=0)
   {
      if ($this->fp===false) {
         return false;
      }
      
      $this->check_pg_open();
      
      $fontRC=(int)@$fontRC; // normalize        
      $brushRC=(int)@$brushRC; // normalize
      $dx=(float)@$dx; // normalize
      $dy=(float)@$dy; // normalize
      return fwrite($this->fp, "<DrawNext font=\"$fontRC\" brush=\"$brushRC\" x=\"$dx\" y=\"$dy\">".$this->myxml($s1)."</DrawNext>");
   }
   
   function draw_rectangle($penRC, $x, $y, $width, $height)
   {
      if ($this->fp===false) {
         return false;
      }

      $this->check_pg_open();      
      
      $penRC=(int)$penRC; // normalize
      return fwrite($this->fp, "<DrawRectangle pen=\"$penRC\">".implode(",", array($x, $y, $width, $height))."</DrawRectangle>");
   }
   
   function draw_lines($penRC, $ar1)
   {
      if ($this->fp===false) {
         return false;
      }
      
      $this->check_pg_open();
      
      if (!is_array($ar1) || count ($ar1)<4) {
         return false;
      } 
      
      return fwrite($this->fp, "<DrawLines pen=\"$penRC\">".implode(",", $ar1)."</DrawLines>");
   }
   
   function draw_image($image, $ulx, $uly, $urx, $ury, $llx, $lly)
   {
      if ($this->fp===false) {
         return false;
      }

      $this->check_pg_open();      
      
      // normalize
      $ulx=(float)$ulx; 
      $uly=(float)$uly; 
      $urx=(float)$urx; 
      $ury=(float)$ury; 
      $llx=(float)$llx; 
      $lly=(float)$lly;
      
      return fwrite($this->fp, "<DrawImage image=\"".$this->myxml($image)."\">$ulx, $uly, $urx, $ury, $llx, $lly</DrawImage>");
   }
   
   function draw_qrcode($data, $ulx, $uly, $urx, $ury, $llx=false, $lly=false)
   {
      if ($this->fp===false) {
         return false;
      }

      $this->check_pg_open();      
      
      // normalize
      $ulx=(float)$ulx; 
      $uly=(float)$uly; 
      $urx=(float)$urx; 
      $ury=(float)$ury;
      if ($llx!==false || $lly!==false) { 
         $llx=(float)$llx; 
         $lly=(float)$lly;
         return fwrite($this->fp, "<DrawQRCode data=\"".$this->myxml($data)."\">$ulx, $uly, $urx, $ury, $llx, $lly</DrawQRCode>");
      }
      else {
         return fwrite($this->fp, "<DrawQRCode data=\"".$this->myxml($data)."\">$ulx, $uly, $urx, $ury</DrawQRCode>");
      } 
   }
}
?>